//-------------------------------------------------------------------
#ifndef __Interupts_H__
#define __Interupts_H__
//-------------------------------------------------------------------
 
#include <arduino.h>

void Setup_Input_Pins(void);
bool Get_Start_State(uint8_t PIN, uint8_t POL);
uint16_t Int_GATE(uint16_t this_val, uint16_t last_val);
void Clear_Start_Interrupts(void);

 
#define INPUT_PIN_HIGH_BEAM_SW    13
#define INPUT_PIN_STARTER_SW      15
#define INPUT_PIN_LEFT_SW         17
#define INPUT_PIN_RIGHT_SW        19 
#define INPUT_PIN_HORN_SW         12
#define INPUT_PIN_KILL_SW         18
#define INPUT_PIN_BRAKE_SW        16
#define INPUT_PIN_LIGHTS_SW       14
#define INPUT_PIN_GATE_SW         A7   // RST lead now on ADC 7 - need to read and measure this pin.


// just for reference - pins are actually using the events
#define INPUT_PIN_UPPER_LEFT  INPUT_PIN_HIGH_BEAM_SW
#define INPUT_PIN_LOWER_LEFT  INPUT_PIN_HORN_SW
#define NPUT_PIN_UPPER_RIGHT  INPUT_PIN_KILL_SW
#define INPUT_PIN_LOWER_RIGHT  INPUT_PIN_STARTER_SW

// event interuppt handlers

extern bool HB_Event_Pending;
extern bool HB_Active;
extern bool STARTER_Event_Pending;
extern bool STARTER_Active;
extern bool LEFT_Event_Pending;
extern bool LEFT_Active;
extern bool RIGHT_Event_Pending;
extern bool RIGHT_Active;
extern bool HORN_Event_Pending;
extern bool HORN_Active;
extern bool KILL_Event_Pending;
extern bool KILL_Active;
extern bool BRAKES_Event_Pending;
extern bool BRAKES_Active;
extern bool LIGHTS_Event_Pending;
extern bool LIGHTS_Active ;
extern bool GATE_Event_Pending;
extern bool GATE_Active;


//-------------------------------------------------------------------

//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
 
 
