
/*************************************************************
  project: <type project name here>
  author: <type your name here>
  description: <type what this file does>
*************************************************************/

//#include "arduino.h"
#include "types.h"
#include "global_data.h"
#include "Menu_types.h"

#include "Interupts.h"
#include "Inputs.h"
#include "KeyMap.h"
#include "Logic.h"
#include "Outputs.h"


//flow of events is 
//Interrupts go to input processing -?
// input processing takes these and creates states vairables

// ie IN - these are state and the button push duration - 0 if state driven
//  update flag if there was an interruptevent / change - needed for toggling
// LIGHTS_IN, UPDATE_LIGHTS_IN,  Lights_In_Duration;
// KILL_IN, UPDATE_LIGHTS_IN   Kill_In_Duration;
// STARTER_IN, UPDATE_STARTER_IN Starter_In_Duration;
// HORN_IN, UPDATE_HORN_IN   Horn_In_Duration;
// BRAKE_IN,UPDATE_BRAKE_IN  Brake_In_Duration;
// LEFT_IN, UPDATE_LEFT_IN  Left_In_Duration;
// RIGHT_IN,UPDATE_RIGHT_IN  Right_In_Duration;
// HIGH_IN, UPDATE_HIGH_IN  High_In_Duration;
// GATE_IN, UPDATE_GATE_IN  Gate_In_Duration;


uint32_t Horn_Expire_Time = 0;
uint32_t Starter_Expire_Time = 0;


uint32_t short_press_last_time = 0;
bool short_press_last = 0; 


// ------------------- 4 Button --------------------------------------------------------------------------------
// here we will map the button pressest to the state functions - as to what button press becomes what

// --------------------------------------------------------------------------------------------------------------------------------------------------------
// 4 button

void DumpMap(byte index)
{
  byte b,t;
  Funct_Ptr val;  // point to the function to call
  
  for (b=0; b< NUM_BUTTONS; b++)
  {
    Serial.print(F("BUTTON :"));
    Serial.print(b,DEC);    
    Serial.print(F(" -> "));   
    for (t=0; t< NUM_TIMINGS; t++)
    {
      switch (index)    
      { 
        case 1:
          //val = Button_Map_1.Execute[b][t];   
          val = (Funct_Ptr) pgm_read_word_near(&(Button_Map_1.Execute[b][t]));     
        break;
        case 2:
          val = (Funct_Ptr) pgm_read_word_near(&(Button_Map_2.Execute[b][t]));  
        break;
        case 3:
          val = (Funct_Ptr) pgm_read_word_near(&(Button_Map_3.Execute[b][t]));    
        break;
        case 4:
          val = (Funct_Ptr) pgm_read_word_near(&(Button_Map_4.Execute[b][t]));       
        break;
        case 0:
        default:  // do nothing
        break;  
      }                
      Serial.print((int)val,HEX);    
      Serial.print(F(", "));        
    }
    Serial.println();    
  }
}


void Do_Mapped_Function(KEYMAP_BUTTON BUTTON, byte INDEX)
{
  Funct_Ptr fnptr  = NULL;  // point to the fucntion to call

#ifdef BUTTON_TRACE_ON   
  switch (BUTTON)
  { 
    case BUTTON_UPPER_LEFT:
      Serial.print(F("UPPER LEFT : "));
    break;
      case BUTTON_LOWER_LEFT:
      Serial.print(F("LOWER LEFT : "));
    break;
      case BUTTON_UPPER_RIGHT:
      Serial.print(F("UPPER RIGHT : "));
    break;
      case BUTTON_LOWER_RIGHT:
      Serial.print(F("LOWER RIGHT : "));
     break;
   default:
     Serial.print(F("BAD BUTTON CODE _ "));
     Serial.println(BUTTON,DEC);
  break;
  }

  switch (INDEX)
  { 
    case INDEX_SHORT:
      Serial.println(F("SHORT"));
    break;
    case INDEX_DOUBLE:
      Serial.println(F("DOUBLE"));    
    break;
      case INDEX_MED:
      Serial.println(F("MEDIUM"));
    break;
      case INDEX_LONG:
      Serial.println(F("LONG"));
    break;
   default:
     Serial.println();
     Serial.print(F("BAD LENGTH CODE _ "));
     Serial.println(INDEX,DEC);
  break;
  } 
#endif    

// Serial.print(F("ACCESSING BUTTON MAP -> "));
// Serial.println(TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num,DEC);
//DumpMap(TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num);

switch (TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num)
{
    case 1:   
      fnptr = (Funct_Ptr) pgm_read_word_near(&(Button_Map_1.Execute[BUTTON][INDEX]));            
    break;
    case 2:
      fnptr = (Funct_Ptr) pgm_read_word_near(&(Button_Map_2.Execute[BUTTON][INDEX]));   
    break;
    case 3:
      fnptr = (Funct_Ptr) pgm_read_word_near(&(Button_Map_3.Execute[BUTTON][INDEX]));           
    break;
    case 4:
      fnptr = (Funct_Ptr) pgm_read_word_near(&(Button_Map_4.Execute[BUTTON][INDEX]));         
    break;
    case 0:
    default:  // do nothing
    break;    
}  
// call the function 
if (fnptr != NULL)
{
//  Serial.print(F("FN_PTR->"));  
//  Serial.println((int)fnptr,HEX); 
  fnptr(BUTTON);  
}
else  
 // Serial.println(F("NULL FN PTR"));
;  
}

bool Check_Timed_Horn_Flag(void)
{
  bool result = false;
  switch (TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num)
  {
    case 1:   
      result =  pgm_read_byte_near(&(Button_Map_1.Timed_Horn));         
    break;
    case 2:
      result =  pgm_read_byte_near(&(Button_Map_2.Timed_Horn));  
    break;
    case 3:
      result =  pgm_read_byte_near(&(Button_Map_3.Timed_Horn));         
    break;
    case 4:
      result =  pgm_read_byte_near(&(Button_Map_4.Timed_Horn));      
    break;
    case 0:
    default:  // do nothing
      result = false;    
    break;    
  }       
  return(result);
}


bool Check_Timed_Starter_Flag(void)
{
  bool result = false;
  switch (TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num)
  {
    case 1:   
      result =  pgm_read_byte_near(&(Button_Map_1.Timed_Starter));         
    break;
    case 2:
      result =  pgm_read_byte_near(&(Button_Map_2.Timed_Starter));  
    break;
    case 3:
      result =  pgm_read_byte_near(&(Button_Map_3.Timed_Starter));         
    break;
    case 4:
      result =  pgm_read_byte_near(&(Button_Map_4.Timed_Starter));      
    break;
    case 0:
    default:  // do nothing
      result = false;    
    break;    
  }       
  return(result);
}

// ----------------------------------------------------------------------
uint32_t Clear_Incoming_Key(KEYMAP_BUTTON key)
{
  uint32_t timer_output;
  switch(key)
  {
    case BUTTON_UPPER_LEFT:  // high in
      timer_output = High_In_Duration; 
      High_In_Duration = 0;
      HIGH_IN = false;
      UPDATE_HIGH_IN = false;
    break;
   case BUTTON_LOWER_LEFT: // horn
      timer_output = Horn_In_Duration;
      Horn_In_Duration = 0;
      HORN_IN = false;
      UPDATE_HORN_IN = false;
    break;
    case BUTTON_UPPER_RIGHT: // lill 
      timer_output = Kill_In_Duration;
      Kill_In_Duration = 0;
      KILL_IN = false;
      UPDATE_KILL_IN = false;
    break;
    case BUTTON_LOWER_RIGHT: // start
      timer_output = Starter_In_Duration; 
      Starter_In_Duration =0;
      STARTER_IN = false;
      UPDATE_STARTER_IN = false;
    break;
    default:
      timer_output = 0;
    break;
  }
  return(timer_output);  
}






// -------------------------------------------------------------------------------------------------------

// rountines set the variables appropriately as though normal buttons were pressed -
// then normal processing is performed 
void Fn_High_Low_Tog(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
   Serial.println(F("HIGH_LOW_TOGGLE"));
#endif
  High_In_Duration = Clear_Incoming_Key(Butt);   // log the press time         
  HIGH_IN = true;  
  UPDATE_HIGH_IN  = true;              
}

void Fn_Lights_Tog(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("LIGHTS_TOGGLE"));
#endif
  Lights_In_Duration = Clear_Incoming_Key(Butt);   // log the press time         
  LIGHTS_IN = true;  
  UPDATE_LIGHTS_IN  = true;              
}

void Fn_Modulation_Tog(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("MODLATION_TOGGLE"));
#endif
  High_In_Duration = Clear_Incoming_Key(Butt);      
  High_In_Duration = (MODULATION_TOGGLE_MAX_DETECT_TIME + MODULATION_TOGGLE_MIN_DETECT_TIME) /2;  // log the press time     
  HIGH_IN = false;  
  UPDATE_HIGH_IN  = true;          
}

void Fn_Heater_Up_step(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("HEATER_UP_STEP"));
#endif  
  Starter_In_Duration = Clear_Incoming_Key(Butt);      
  Starter_In_Duration = (MIN_DUR + MAX_SHORT)/2 ;   // log the press time         
  STARTER_IN = false;  
  UPDATE_STARTER_IN  = true;  
  // for heater functions need to ensurethe GATE is off - as this is the overlapped starter function
  GATE_IN = false;
}

void Fn_Heater_On_Tog(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON   
  Serial.println(F("HEATER_ON_TOGGLE"));
#endif 
  Starter_In_Duration =  Clear_Incoming_Key(Butt);   
  Starter_In_Duration =  MIN_DUR + MIN_LONG;        
  STARTER_IN = false;  
  UPDATE_STARTER_IN  = true;  
  // for heater functions need to ensurethe GATE is off - as this is the overlapped starter function 
  GATE_IN = false;     
}


void Fn_Kill_ON_Toggle(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON    
  Serial.println(F("KILL_ON_TOGGLE"));
#endif
  Kill_In_Duration =  Clear_Incoming_Key(Butt);   // log the press time         
  KILL_IN = true;  
  UPDATE_KILL_IN  = true;          
}

void Fn_HORN_On_Time(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON    
  Serial.println(F("HORN_ON_TOGGLE"));
#endif    
  Horn_In_Duration =  Clear_Incoming_Key(Butt);  // work out the button time 
  HORN_IN = true; 
  UPDATE_HORN_IN  = true;  
  Horn_Expire_Time = millis() + HORN_ON_TIME;                
}

void Fn_Starter_On_Time(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("STARTER_ON_TOGGLE"));
#endif
  Starter_In_Duration =  Clear_Incoming_Key(Butt);  // work out the button time  
  STARTER_IN = true;
  UPDATE_STARTER_IN  = true;   
  Starter_Expire_Time = millis() + STARTER_ON_TIME;            
}

void Fn_Left_Ind_Tog(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("LEFT_IND_TOGGLE"));
#endif  
  Left_In_Duration =  Clear_Incoming_Key(Butt);  // log the press time         
  LEFT_IN = true;  
  UPDATE_LEFT_IN  = true;   
  IND_MERGE_FLAG = false;        
}

void Fn_Left_Ind_Merge(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("LEFT_IND_MERGE"));
#endif  
  Left_In_Duration =  Clear_Incoming_Key(Butt);   // log the press time         
  LEFT_IN = true;  
  UPDATE_LEFT_IN  = true;     
  IND_MERGE_FLAG = true;     
}


void Fn_Right_Ind_Tog(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("RIGHT_IND_TOGGLE"));
#endif
  Right_In_Duration =  Clear_Incoming_Key(Butt);  // work out the button time  
  RIGHT_IN = true;
  UPDATE_RIGHT_IN  = true;     
  IND_MERGE_FLAG = false;     
}

void Fn_Right_Ind_Merge(KEYMAP_BUTTON Butt)
{
#ifdef MAP_TRACE_ON  
  Serial.println(F("RIGHT_IND_MERGE"));
#endif
  Right_In_Duration =  Clear_Incoming_Key(Butt);  // work out the button time  
  RIGHT_IN = true;
  UPDATE_RIGHT_IN  = true;     
  IND_MERGE_FLAG = true;   
}

// 

bool  Check_Double_Press(KEYMAP_BUTTON BUTTON, byte INDEX)
{
  bool executed_flag = false;
#ifdef MAP_TRACE_ON  
  Serial.print(F("Check DOUBLE ->"));
#endif  
  if (short_press_last == true)  // we have a short press not long ago 
  {
    if ((millis() - short_press_last_time) <= DOUBLE_PRESS_TIME_WINDOW)
    {  
#ifdef MAP_TRACE_ON  
      Serial.println(F("SECOND"));
#endif      
      Do_Mapped_Function(BUTTON, INDEX); 
      executed_flag = true;   // indicate that there is stuff to process 
    }      
    short_press_last = false;
    short_press_last_time = 0;        
  }  
  else // first press - flag it 
  { // clear out the press    
#ifdef MAP_TRACE_ON  
     Serial.println(F("FIRST"));
#endif           
    short_press_last_time = millis();
    short_press_last = true;                          
  }
  return(executed_flag);   
}



bool Check_UPPER_RIGHT_In(void)
{
  Funct_Ptr  fnptr;
  bool exec_pending = false;
  // map the button presses tot he functions ?
  // kill switch mapps to the upper right
  if (true == UPDATE_KILL_IN)
  {
    if (Kill_In_Duration > 0)
    {  
#ifdef MAP_TRACE_ON        
      Serial.println(F("ACTIVE UPPER RIGHT"));  // HORN switch mapps to the lower left
#endif 
      // need to do the double press first to leave the duration alone 
      if ((Kill_In_Duration >= BOUNCE_DUR) && (Kill_In_Duration < MIN_DUR))
        exec_pending =  Check_Double_Press (BUTTON_UPPER_RIGHT, INDEX_DOUBLE);                 
      else 
      { 
        short_press_last = false;
        short_press_last_time = 0;    
      } 
      
      if (false == exec_pending)        // check others if not a pending function
      {
        if ((Kill_In_Duration >= MIN_DUR) && (Kill_In_Duration <= MAX_SHORT))
          Do_Mapped_Function(BUTTON_UPPER_RIGHT, INDEX_SHORT);           
        else if ((Kill_In_Duration >= MAX_SHORT) && (Kill_In_Duration <= MIN_LONG)) // Long
          Do_Mapped_Function(BUTTON_UPPER_RIGHT, INDEX_MED);
        else if ((Kill_In_Duration >= MIN_LONG))
          Do_Mapped_Function(BUTTON_UPPER_RIGHT, INDEX_LONG);         
        else      
          Clear_Incoming_Key(BUTTON_UPPER_RIGHT);   
      }       
    }
    else  
      Clear_Incoming_Key(BUTTON_UPPER_RIGHT);    

    return(true);
  }
  return (false);
}  


bool  Check_LOWER_RIGHT_In(void)
{
  Funct_Ptr  fnptr;
  bool exec_pending = false;
  // map the button presses tot he functions ?
  // Starter switch mapps to the lower right
  if (true == UPDATE_STARTER_IN)
  {  
    if  (Starter_In_Duration > 0)
    {  
      Starter_Expire_Time  = 0;    
#ifdef MAP_TRACE_ON       
      Serial.println(F("ACTIVE LOWER RIGHT"));  // HORN switch mapps to the lower right
#endif   
      // fo first   
      if ((Starter_In_Duration >= BOUNCE_DUR) && (Starter_In_Duration < MIN_DUR))
         exec_pending = Check_Double_Press (BUTTON_LOWER_RIGHT, INDEX_DOUBLE);                        
      else 
      { 
        short_press_last = false;
        short_press_last_time = 0;    
      }   
      if (false == exec_pending)        // check others if not a pending function
      {
        if ((Starter_In_Duration >= MIN_DUR) && (Starter_In_Duration <= MAX_SHORT))
          Do_Mapped_Function(BUTTON_LOWER_RIGHT, INDEX_SHORT);                  
        else if ((Starter_In_Duration >= MAX_SHORT) && (Starter_In_Duration <= MIN_LONG)) // Long
          Do_Mapped_Function(BUTTON_LOWER_RIGHT, INDEX_MED);
        else if ((Starter_In_Duration >= MIN_LONG))
          Do_Mapped_Function(BUTTON_LOWER_RIGHT, INDEX_LONG);               
        else
          Clear_Incoming_Key(BUTTON_LOWER_RIGHT);  
        } 
    }    
    else
      Clear_Incoming_Key(BUTTON_LOWER_RIGHT);   

    return(true);   
  }  
  return (false);
}  

bool  Check_UPPER_LEFT_In(void)
{
  Funct_Ptr  fnptr;  
  bool exec_pending = false;
  // need to know what the button is and then based on duration - activate function ?
    // map the button presses tot he functions ?
  // hgih beam switch mapps to the upper left
  if (true == UPDATE_HIGH_IN)
  {  
    if  (High_In_Duration > 0)
    { 
#ifdef MAP_TRACE_ON                 
      Serial.println(F("ACTIVE UPPER LEFT"));  // HORN switch mapps to the lower left
#endif 
      // do first
      if ((High_In_Duration >= BOUNCE_DUR) && (High_In_Duration < MIN_DUR))
         exec_pending = Check_Double_Press (BUTTON_UPPER_LEFT, INDEX_DOUBLE);                       
      else 
      { 
        short_press_last = false;
        short_press_last_time = 0;    
      }  
      if (false == exec_pending)        // check others if not a pending function
      {
        if ((High_In_Duration >= MIN_DUR) && (High_In_Duration <= MAX_SHORT))
          Do_Mapped_Function(BUTTON_UPPER_LEFT, INDEX_SHORT);   
        else if ((High_In_Duration >= MAX_SHORT) && (High_In_Duration <= MIN_LONG)) // Long
          Do_Mapped_Function(BUTTON_UPPER_LEFT, INDEX_MED);   
        else if ((High_In_Duration >= MIN_LONG))
          Do_Mapped_Function(BUTTON_UPPER_LEFT, INDEX_LONG);   
        else
          Clear_Incoming_Key(BUTTON_UPPER_LEFT);        
      }
    }
    else
      Clear_Incoming_Key(BUTTON_UPPER_LEFT);   
       
    return(true);       
  }          
  return (false);
}  

bool Check_LOWER_LEFT_In(void)
{
  Funct_Ptr  fnptr;
  bool exec_pending = false;
  // map the button presses tot he functions ?
  if ((true == UPDATE_HORN_IN) )
  { 
    if (Horn_In_Duration > 0) // button release 
    {   
      Horn_Expire_Time = 0;  
#ifdef MAP_TRACE_ON  
      Serial.println(F("ACTIVE LOWER LEFT"));  // HORN switch mapps to the lower left
#endif  
      // do first
      if ((Horn_In_Duration >= BOUNCE_DUR) && (Horn_In_Duration < MIN_DUR))
         exec_pending = Check_Double_Press (BUTTON_LOWER_LEFT, INDEX_DOUBLE);                        
      else 
      { 
        short_press_last = false;
        short_press_last_time = 0;    
      }   
      if (false == exec_pending)        // check others if not a pending function
      {       
        if ((Horn_In_Duration >= MIN_DUR) && (Horn_In_Duration <= MAX_SHORT))
          Do_Mapped_Function(BUTTON_LOWER_LEFT, INDEX_SHORT);   
        else if ((Horn_In_Duration >= MAX_SHORT) && (Horn_In_Duration <= MIN_LONG)) // Long
          Do_Mapped_Function(BUTTON_LOWER_LEFT, INDEX_MED);   
        else if ((Horn_In_Duration >= MIN_LONG))
          Do_Mapped_Function(BUTTON_LOWER_LEFT, INDEX_LONG);    
        else
          Clear_Incoming_Key(BUTTON_LOWER_LEFT);    
      }                
    }        
    else
      Clear_Incoming_Key(BUTTON_LOWER_LEFT);     
 
    return(true) ;             
  }
  return (false);
}  


// ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void   Check_Timed_Function_Expire()
  {
  // check the   
  //timer expiration of the horn and the starter funtions - and set events as appropriate
 
  if  (true == Check_Timed_Horn_Flag())
  {
    if ((Horn_Expire_Time != 0) && (millis() >= Horn_Expire_Time))
    {
      // turn off the HORN - operate it in state mode
      HORN_IN = (TheConfigEpromData.Values[CONFIG_PARAM_HORN_MODE].Bool == false) ? true : false;  
      UPDATE_HORN_IN = true;
      Horn_In_Duration = 0;
      Horn_Expire_Time = 0; // tunr the timer off
#ifdef MAP_TRACE_ON    
      Serial.println(F("TURNING OFF HORN"));  
#endif        
    }  
  }  

  if (true == Check_Timed_Starter_Flag())
  { 
    if ((Starter_Expire_Time != 0) && (millis() >= Starter_Expire_Time))
    {
      // turn off the HORN - operate it in state mode
      STARTER_IN = (TheConfigEpromData.Values[CONFIG_PARAM_STARTER_MODE].Bool == false) ? true : false;        
      UPDATE_STARTER_IN = true;
      Starter_Expire_Time = 0; 
#ifdef MAP_TRACE_ON    
      Serial.println(F("TURNING OFF STARTER"));     
#endif
    } 
  }    
}


// --------------------------------------------------------------------------------------------------------------------
// .this one needs to usethe time funtions in order to mapp the inputs to the actual functions
bool Do_4Button_Map()
{
  bool Update_flag = false;
  // process button presses into the normal set of operating flags
  // only process one though else they might obsure each other
  if (false ==  Check_LOWER_LEFT_In()) {
   if (false == Check_UPPER_LEFT_In()) {
       if (false == Check_LOWER_RIGHT_In()) 
          Check_UPPER_RIGHT_In(); 
   }
 }  
 

  Check_Timed_Function_Expire();  
  return(Update_flag);
}


// --------------------------------------------------------------------------------------------------------------------------------------------------------
 void  Do_Mapping(void)
 {
    if ((TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num != 0))
      Do_4Button_Map();
    else
      ;  // leave as normal
 }
 