
/*************************************************************
  project: <type project name here>
  author: <type your name here>
  description: <type what this file does>
*************************************************************/

//#include "arduino.h"
#include "types.h"
#include "global_data.h"

#include "Interupts.h"
#include "Inputs.h"
#include "Logic.h"
#include "Outputs.h"

#include  "menu.h"

// need to acces accros to the PWMM functions which can only exist in the main code block due to the PWM modules
void Set_LOW_BEAM(uint8_t Sett);
void Set_SPARE_HEAT(uint8_t Sett);

#define NUM_MOD_VALS       5
const uint8_t MOD_ARRAY[] = {0,50,100,100,50,0};




// output variables
bool HORN_OUT = false;
bool HORN_CURRENT = false;
uint32_t Horn_Out_Start = 0;

bool LIGHTS_OUT = false;
bool LIGHTS_CURRENT = false;
uint32_t Lights_Out_Start = 0;

bool STARTER_OUT = false;
bool STARTER_CURRENT = false;
uint32_t Starter_Out_Start = 0;

bool BRAKE_OUT = false;
bool BRAKE_CURRENT = false;
uint32_t Brake_Out_Start = 0;

bool IND_MERGE_FLAG = false; // merge mode

bool LEFT_IND_OUT = false;
bool LEFT_IND_CURRENT = false;
uint32_t Left_Out_Start = 0;

bool RIGHT_IND_OUT = false;
bool RIGHT_IND_CURRENT = false;
uint32_t Right_Out_Start = 0;

bool HIGH_BEAM_OUT = false;
bool HIGH_BEAM_CURRENT = false;
uint32_t High_Beam_Out_Start = 0;

bool IGNITION_OUT = true;  // default to on 
bool IGNITION_CURRENT  = false;
uint32_t Ignition_Out_Start = 0;


// external
bool LOW_BEAM_OUT = false;
uint8_t LOW_MOD_OUT_VAL = 0;
bool LOW_BEAM_MOD_ON = false;
// internal
bool LOW_BEAM_CURRENT = false;
uint8_t  LOW_MOD_CURRENT_VAL = 0;
uint32_t Mod_Out_Start = 0;


// external
uint8_t SPARE_PWM_OUT_VAL = 0;
bool SPARE_OUT = false;
// internal
uint8_t SPARE_PWM_CURRENT_VAL = 100;  // initally set on so the change to off at initialisation is actioned
bool SPARE_CURRENT = true;
uint32_t Spare_Out_Start = 0;





void Setup_Output_Pins(void)
{
  // configure the output pins
  pinMode ( OUTPUT_PIN_HIGH_BEAM, OUTPUT);    
  pinMode ( OUTPUT_PIN_LOW_BEAM, OUTPUT);   
  pinMode ( OUTPUT_PIN_LIGHT_ON, OUTPUT);   
  pinMode ( OUTPUT_PIN_STARTER, OUTPUT);   

  pinMode ( OUTPUT_PIN_LEFT_IND, OUTPUT);   
  pinMode ( OUTPUT_PIN_RIGHT_IND, OUTPUT);   
  pinMode ( OUTPUT_PIN_HORN, OUTPUT);   

  pinMode ( OUTPUT_PIN_BRAKE, OUTPUT);   
  pinMode ( OUTPUT_PIN_IGNITION, OUTPUT);   
  pinMode ( OUTPUT_PIN_SPARE, OUTPUT);   

  // set the initial states - read these from the states most should be off but cant be sure.

  digitalWrite ( OUTPUT_PIN_HIGH_BEAM, OUTPUT_OFF);    
  digitalWrite ( OUTPUT_PIN_LOW_BEAM, OUTPUT_OFF);   
  digitalWrite ( OUTPUT_PIN_LIGHT_ON, OUTPUT_OFF);   
  digitalWrite ( OUTPUT_PIN_STARTER, OUTPUT_OFF);   

  digitalWrite ( OUTPUT_PIN_LEFT_IND, OUTPUT_OFF);   
  digitalWrite ( OUTPUT_PIN_RIGHT_IND, OUTPUT_OFF);   
  digitalWrite ( OUTPUT_PIN_HORN, OUTPUT_OFF);

  digitalWrite ( OUTPUT_PIN_BRAKE, OUTPUT_OFF);   
  digitalWrite ( OUTPUT_PIN_IGNITION, OUTPUT_OFF);   // invert igntion power
  digitalWrite ( OUTPUT_PIN_SPARE, OUTPUT_OFF); 
  
}  


void Process_Normal_Initial_State(void)
{
  HIGH_IN = Get_Start_State(INPUT_PIN_HIGH_BEAM_SW, CONFIG_PARAM_HIGH_POL); 
  UPDATE_HIGH_IN = true;
  High_In_Duration = (MIN_DUR + MAX_SHORT)/2;    
  

  LIGHTS_IN = Get_Start_State(INPUT_PIN_LIGHTS_SW, CONFIG_PARAM_LIGHTS_POL); 
  UPDATE_LIGHTS_IN = true;
  Lights_In_Duration = (MIN_DUR + MAX_SHORT)/2;
  

  STARTER_IN = Get_Start_State(INPUT_PIN_STARTER_SW, CONFIG_PARAM_STARTER_POL);
  //UPDATE_STARTER_IN = true;
  UPDATE_STARTER_IN = false; // want to avoid starter overwriting the high beam flag 
  Starter_In_Duration = (MIN_DUR + MAX_SHORT)/2;    
  

  LEFT_IN =  Get_Start_State(INPUT_PIN_LEFT_SW, CONFIG_PARAM_LEFT_POL);
  UPDATE_LEFT_IN = true;
  Left_In_Duration = (MIN_DUR + MAX_SHORT)/2;   

  RIGHT_IN =  Get_Start_State(INPUT_PIN_RIGHT_SW, CONFIG_PARAM_RIGHT_POL);
  UPDATE_RIGHT_IN = true;
  Right_In_Duration = (MIN_DUR + MAX_SHORT)/2;

  HORN_IN = Get_Start_State (INPUT_PIN_HORN_SW, CONFIG_PARAM_HORN_POL);
  UPDATE_HORN_IN = true;
  Horn_In_Duration = (MIN_DUR + MAX_SHORT)/2;


  BRAKE_IN = Get_Start_State(INPUT_PIN_BRAKE_SW, CONFIG_PARAM_BRAKE_POL);
  UPDATE_BRAKE_IN = true;
  Brake_In_Duration = (MIN_DUR + MAX_SHORT)/2;


  KILL_IN = Get_Start_State(INPUT_PIN_KILL_SW, CONFIG_PARAM_KILL_POL);  // invert igntion power
  UPDATE_KILL_IN = true; //KILL_IN; // update if kill on - default is off
  Kill_In_Duration = (MIN_DUR + MAX_SHORT)/2; 

 
  GATE_IN = Get_Start_State(INPUT_PIN_GATE_SW, CONFIG_PARAM_GATE_POL);
  UPDATE_GATE_IN = true;
  Gate_In_Duration = (MIN_DUR + MAX_SHORT)/2;

  SPARE_OUT = false; 
  SPARE_PWM_OUT_VAL = Read_Byte_From_Flash(STORED_HEAT_SETTING_ADDRESS);  // set to off initially
  
 
}
// -------------------------------------------------------------------------------------------------------------------

void Button4_Process_Initial_State(void)
{
  HIGH_IN = false; 
  UPDATE_HIGH_IN = false;
  High_In_Duration = (MIN_DUR + MAX_SHORT)/2;    
  
  LIGHTS_IN = false;
  UPDATE_LIGHTS_IN = false;
  Lights_In_Duration = (MIN_DUR + MAX_SHORT)/2;

  STARTER_IN = false;
  UPDATE_STARTER_IN = false; 
  Starter_In_Duration = (MIN_DUR + MAX_SHORT)/2;    
  
  LEFT_IN =  false;
  UPDATE_LEFT_IN = false;
  Left_In_Duration = (MIN_DUR + MAX_SHORT)/2;   

  RIGHT_IN =  false;
  UPDATE_RIGHT_IN = false;
  Right_In_Duration = (MIN_DUR + MAX_SHORT)/2;

  HORN_IN = false;
  UPDATE_HORN_IN = false;
  Horn_In_Duration = (MIN_DUR + MAX_SHORT)/2;
  
  KILL_IN = false;  // invert igntion power
  UPDATE_KILL_IN = false; //KILL_IN; // update if kill on - default is off
  Kill_In_Duration = (MIN_DUR + MAX_SHORT)/2; 

  BRAKE_IN = Get_Start_State(INPUT_PIN_BRAKE_SW, CONFIG_PARAM_BRAKE_POL);
  UPDATE_BRAKE_IN = true;
  Brake_In_Duration = (MIN_DUR + MAX_SHORT)/2;

  GATE_IN = Get_Start_State(INPUT_PIN_GATE_SW, CONFIG_PARAM_GATE_POL);
  UPDATE_GATE_IN = true;
  Gate_In_Duration = (MIN_DUR + MAX_SHORT)/2;

  SPARE_OUT = false; 
  SPARE_PWM_OUT_VAL = Read_Byte_From_Flash(STORED_HEAT_SETTING_ADDRESS);  // set to off initially
}


void Process_Initial_State(void)
{
  if ((TheConfigEpromData.Values[CONFIG_PARAM_4_BUTTON_MODE].Num != 0))
    Button4_Process_Initial_State();
  else
    Process_Normal_Initial_State();
}


 // ----------------------------------------------------------------------------------------------------------------- 
    
    
    // ===================================================================================================
void Do_Horn_Output(void)
{
  if  (HORN_OUT  != HORN_CURRENT)  // State change
  {
      if (true == HORN_OUT)
      {
        HORN_CURRENT = true;
        Horn_Out_Start = millis();        // record the on time   
        digitalWrite ( OUTPUT_PIN_HORN, OUTPUT_ON);   
      }          
      else
      {
        HORN_CURRENT = false;
        Horn_Out_Start = 0;   
        digitalWrite ( OUTPUT_PIN_HORN, OUTPUT_OFF);   
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}

void Do_Starter_Output(void)
{
  if  (STARTER_OUT  != STARTER_CURRENT)  // State change
  {
      if (true == STARTER_OUT)
      {
        STARTER_CURRENT = true;
        Starter_Out_Start = millis();        // record the on time 
        digitalWrite ( OUTPUT_PIN_STARTER, OUTPUT_ON);             
      }
      else
      {
        STARTER_CURRENT = false;
        Starter_Out_Start = 0;
        digitalWrite ( OUTPUT_PIN_STARTER, OUTPUT_OFF);            
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}


// brake
uint32_t Brake_Timer = 0;
uint32_t Brake_Interval = 0;
uint16_t Brake_Counter = 0;
bool BRAKE_STATE_ON = false;
bool BRAKE_FLASH_ON = false;

void Do_Brake_Output(void)
{
  if  (BRAKE_OUT  != BRAKE_CURRENT)  // State change
  {
      if (true == BRAKE_OUT)
      {
        BRAKE_CURRENT = true;
        Brake_Out_Start = millis();        // record the on time   
        // setup the           flasher          
        Brake_Timer = Brake_Out_Start;   // set the end timeout
        Brake_Interval =  100; // ms
        Brake_Counter = 2 * TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WARN_FLASH_VALUE].Num;
        if (TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WARN_FLASH_FLAG].Bool == true) 
            BRAKE_FLASH_ON = true;    
          BRAKE_STATE_ON = true;    
        digitalWrite ( OUTPUT_PIN_BRAKE, OUTPUT_ON);             
      }
      else
      {
        BRAKE_CURRENT = false;
        Brake_Out_Start = 0;
        
        BRAKE_FLASH_ON = false;    
        BRAKE_STATE_ON = false;
        Brake_Counter =0;
        digitalWrite ( OUTPUT_PIN_BRAKE, OUTPUT_OFF);     
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}


void Do_Lights_Output(void)
{
  if  (LIGHTS_OUT  != LIGHTS_CURRENT)  // State change
  {
      if (true == LIGHTS_OUT)
      {
        LIGHTS_CURRENT = true;
        Lights_Out_Start = millis();        // record the on time  
        digitalWrite ( OUTPUT_PIN_LIGHT_ON, OUTPUT_ON);              
      }
      else
      {
        LIGHTS_CURRENT = false;
        Lights_Out_Start = 0;
        digitalWrite ( OUTPUT_PIN_LIGHT_ON, OUTPUT_OFF);    
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
  
  // OVERRIDES
  // if (TheConfigEpromData.Values[CONFIG_PARAM_LIGHT_ON_POW].Bool == true)
  //     LIGHTS_OUT = true; // always on if power    
}
  

void Do_High_Beam_Output(void)
{
  if  (HIGH_BEAM_OUT != HIGH_BEAM_CURRENT)  // State change
  {
      if (true == HIGH_BEAM_OUT)
      {
        HIGH_BEAM_CURRENT = true;
        High_Beam_Out_Start = millis();        // record the on time 
        digitalWrite ( OUTPUT_PIN_HIGH_BEAM, OUTPUT_ON);       
      }
      else
      {
        HIGH_BEAM_CURRENT = false;
        High_Beam_Out_Start = 0;
        digitalWrite ( OUTPUT_PIN_HIGH_BEAM, OUTPUT_OFF);      
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}


void Do_Low_Beam_Output(void)
{
  if  (LOW_BEAM_OUT  != LOW_BEAM_CURRENT)  // State change
  {
      if (true == LOW_BEAM_OUT)
      {
        LOW_BEAM_CURRENT = true;
        Mod_Out_Start = millis();        // record the on time 
        digitalWrite ( OUTPUT_PIN_LOW_BEAM, OUTPUT_ON);            
      }
      else
      {
        LOW_BEAM_CURRENT = false;
        Mod_Out_Start = 0;
        digitalWrite ( OUTPUT_PIN_LOW_BEAM, OUTPUT_OFF); 
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}


// indicator
bool IND_STATE_ON = false;

uint32_t Ind_Timer = 0;  // put your main code here, to run repeatedly:
uint32_t Ind_Stop_Time = 0;
uint32_t Ind_Interval = 0;

void Do_Left_Output(void)
{
  if  (LEFT_IND_OUT  != LEFT_IND_CURRENT)  // State change
  {
      if (true == LEFT_IND_OUT)
      {
        LEFT_IND_CURRENT = true;
        Left_Out_Start = millis();        // record the on time  
    
        // need to start the indicator process  
        Ind_Timer = millis();   // set the end timeout
        Ind_Interval =  500 / TheConfigEpromData.Values[CONFIG_PARAM_IND_FLASH_RATE_VALUE].Num;
        if ( false == IND_MERGE_FLAG)  
          Ind_Stop_Time = (TheConfigEpromData.Values[CONFIG_PARAM_IND_MAX_FLASH_FLAG].Bool == true) ? (millis() + TheConfigEpromData.Values[CONFIG_PARAM_IND_MAX_LIM_VALUE].Num * 1000 ) : millis() + 120000;
        else
          Ind_Stop_Time = (millis() + IND_MERGE_TIME ); // merging   
        
        IND_STATE_ON = true;
        digitalWrite (OUTPUT_PIN_LEFT_IND , OUTPUT_ON); 
        digitalWrite (OUTPUT_PIN_RIGHT_IND , OUTPUT_OFF);            
      }
      else
      {
        LEFT_IND_CURRENT = false;
        Left_Out_Start = 0;
        
        IND_STATE_ON = false;         
        digitalWrite ( OUTPUT_PIN_LEFT_IND, OUTPUT_OFF); 
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}

void Do_Right_Output(void)
{
  if  (RIGHT_IND_OUT  != RIGHT_IND_CURRENT)  // State change
  {
      if (true == RIGHT_IND_OUT)
      {
        RIGHT_IND_CURRENT = true;
        Right_Out_Start = millis();        // record the on time  
        
        Ind_Timer = millis();   // set the end timeout
        Ind_Interval =  500 / TheConfigEpromData.Values[CONFIG_PARAM_IND_FLASH_RATE_VALUE].Num;
        if( false == IND_MERGE_FLAG)        
          Ind_Stop_Time = (TheConfigEpromData.Values[CONFIG_PARAM_IND_MAX_FLASH_FLAG].Bool == true) ? (millis() + TheConfigEpromData.Values[CONFIG_PARAM_IND_MAX_LIM_VALUE].Num * 1000 ) : millis() + 120000; // normal
        else   
          Ind_Stop_Time =  (millis() +  IND_MERGE_TIME ); // merging              
        
        IND_STATE_ON = true;
  
        digitalWrite (OUTPUT_PIN_RIGHT_IND , OUTPUT_ON); 
        digitalWrite (OUTPUT_PIN_LEFT_IND , OUTPUT_OFF);            
      }
      else
      {
        RIGHT_IND_CURRENT = false;
        Right_Out_Start = 0;

        IND_STATE_ON = false;
        digitalWrite ( OUTPUT_PIN_RIGHT_IND, OUTPUT_OFF);           
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}


void Do_Ignition_Output(void)
{
  if  (IGNITION_OUT != IGNITION_CURRENT)  // State change
  {
      if (true == IGNITION_OUT)
      {
        IGNITION_CURRENT = true;
        Ignition_Out_Start = millis();        // record the on time 
        digitalWrite ( OUTPUT_PIN_IGNITION, OUTPUT_ON);           
      }
      else
      {
        IGNITION_CURRENT = false;
        Ignition_Out_Start = 0;
        digitalWrite ( OUTPUT_PIN_IGNITION, OUTPUT_OFF);         
      } 
  } 
  else
  {
    ;  // no change do nothing
  }
}



// // modulation
uint32_t LAST_MOD_TIME = millis();
uint8_t  LAST_MOD_VAL = 0;

void Do_Mod_Output(void)
{  
  if(millis() - LAST_MOD_TIME >=  BASE_MOD_RATE)  // check if its modulation update time 
  { 
    LAST_MOD_VAL  = (LAST_MOD_VAL > NUM_MOD_VALS) ?  0 : LAST_MOD_VAL+1;    
    if (LOW_BEAM_MOD_ON == true )     
    {
        LOW_MOD_OUT_VAL = 100 - (((uint16_t)MOD_ARRAY[LAST_MOD_VAL] * (uint16_t)TheConfigEpromData.Values[CONFIG_PARAM_MOD_LOW_DEPTH].Num)/100);
        LAST_MOD_TIME = millis(); // update thje time 
    }                           
    else
      LOW_MOD_OUT_VAL = true ;
  }
 
  if  ((LOW_BEAM_OUT  != LOW_BEAM_CURRENT) || (LOW_MOD_OUT_VAL != LOW_MOD_CURRENT_VAL ))  // State change or PWM change
  {         
    if (true == LOW_BEAM_OUT) // its on 
    {
       Mod_Out_Start = millis();   // record change time  
       Set_LOW_BEAM(LOW_MOD_OUT_VAL);  // set the modulation value
    }      
    else
    {
      Mod_Out_Start = 0;
      Set_LOW_BEAM(false);  // turn it off 
    } 

    LOW_BEAM_CURRENT = LOW_BEAM_OUT;
    LOW_MOD_CURRENT_VAL = LOW_MOD_OUT_VAL;
  } 
  else
  {
    ;  // no change do nothing
  }
}


void Do_Spare_Output(void)
{
  if  ((SPARE_OUT != SPARE_CURRENT) || (SPARE_PWM_OUT_VAL != SPARE_PWM_CURRENT_VAL ))  // State change or PWM change
  {
    if (true == SPARE_OUT) // its on 
    {
      Spare_Out_Start = millis();        // record change time    
      Set_SPARE_HEAT(SPARE_PWM_OUT_VAL);                     
    }
    else
    {
      Spare_Out_Start = 0;
      Set_SPARE_HEAT(false);  // turn it to zero
    } 

    SPARE_CURRENT = SPARE_OUT;
    SPARE_PWM_CURRENT_VAL = SPARE_PWM_OUT_VAL;
  } 
  else
  {
    ;  // no change do nothing
  }
}





void Update_Timed_Functions(void)
{
  
  // here we update the state variable for autonomus functions on the flashing 
  // IND_FLASH_STATE, IND_TIME_FLASH, IND_COUNT_FLASH
  // BRAKE_TIME_FLASH, BRAKE_COUNT_FLASH


  // indicator flashes
  // flash indicatoros  + count pulses 
  if  ((millis() - Ind_Timer) >= Ind_Interval)
  {
    if(millis() >= Ind_Stop_Time)
    {
      Ind_Timer = millis();   // set the end timeout
      Ind_Interval =  500 / TheConfigEpromData.Values[CONFIG_PARAM_IND_MAX_LIM_VALUE].Num;
      Ind_Stop_Time = 0;
      digitalWrite (OUTPUT_PIN_LEFT_IND , OUTPUT_OFF); 
      digitalWrite (OUTPUT_PIN_RIGHT_IND , OUTPUT_OFF); 
      IND_STATE_ON = false;  
      LEFT_IND_OUT = false;       
      RIGHT_IND_OUT = false;  
      IND_MERGE_FLAG = false; // clear the merge
      
          
      // CHECK BRAKE STATE
      if ((TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG].Bool == true) && (BRAKE_STATE_ON))
        digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_ON); 
    }
    else
    {
      IND_STATE_ON = !IND_STATE_ON;
      
      if (LEFT_IND_OUT == true)
      {
        if (IND_STATE_ON == true)
        {
            digitalWrite (OUTPUT_PIN_LEFT_IND , OUTPUT_ON);
            if (TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG].Bool == true)
              digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_OFF); 
        }
        else
        {
            digitalWrite (OUTPUT_PIN_LEFT_IND , OUTPUT_OFF); 
            if ((TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG].Bool == true) && (BRAKE_STATE_ON))
              digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_ON); 
        }
      }
      
      if (RIGHT_IND_OUT == true)
      {
        if (IND_STATE_ON == true)
        {
          digitalWrite (OUTPUT_PIN_RIGHT_IND , OUTPUT_ON); 
          if (TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG].Bool == true)
              digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_OFF); 
        }
        else
        {
          digitalWrite (OUTPUT_PIN_RIGHT_IND , OUTPUT_OFF); 
          if ((TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG].Bool == true) && (BRAKE_STATE_ON))
              digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_ON); 
        }
      }  
    }
    
    Ind_Timer = millis();
  }

  // flash BRAKE  + count pulses 
  if (BRAKE_FLASH_ON == true)   
  {
    if  ((millis() - Brake_Timer) >= Brake_Interval)
    {
      if((Brake_Counter-- > 0) && (BRAKE_FLASH_ON == true))
      {
        // toggel the brake light
        BRAKE_STATE_ON = !BRAKE_STATE_ON;
        if (BRAKE_STATE_ON == true)
          digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_ON); 
        else
          digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_OFF);     
      }
      else
      {
        Brake_Counter = 0;
        BRAKE_FLASH_ON = false;
        if (BRAKE_OUT)
        {  
            BRAKE_STATE_ON = true;
            if ((TheConfigEpromData.Values[CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG].Bool == true) && (IND_STATE_ON == true ))
              digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_OFF);
            else
              digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_ON); 
        }
        else
            digitalWrite (OUTPUT_PIN_BRAKE , OUTPUT_OFF);   
      }
      Brake_Timer = millis();
    }
  }

  // PWM or On OFF contol
  // LOW_MOD_VALUE, LOW_MOD_TIME
  Do_Mod_Output();  
  // PWM _VALUE, PWM_TIME  
  Do_Spare_Output();

}


void Do_Outputs(void)
{
  // on / off onoly controls     
  Do_Horn_Output();  
  Do_Lights_Output();
  Do_Brake_Output();
  Do_Starter_Output(); 
  Do_High_Beam_Output();
  Do_Low_Beam_Output();

  Do_Left_Output();
  Do_Right_Output();
  Do_Ignition_Output();
  
  Update_Timed_Functions();
}









