//-------------------------------------------------------------------
#ifndef __global_data_H__
#define __global_data_H__
//-------------------------------------------------------------------

#include <arduino.h>

// used for driving LEDS directly
#define OUTPUT_ON HIGH
#define OUTPUT_OFF LOW

// button opress for heat control
#define BOUNCE_DUR 60
#define MIN_DUR 300
#define MAX_SHORT 1000
#define MIN_LONG 3500
#define MAX_LONG 10000

#define DOUBLE_PRESS_TIME_WINDOW 800  // two press half second

#define IND_MERGE_TIME 4000   // 5s
// // driving FET outputs thogh the inverters
// #define OUTPUT_ON 1
// #define OUTPUT_OFF 0

//#define STATE_TRACE_ON 1  // output the curretn states insterad of the menu system
//#define STATE_TRACE_INTERVAL 5000 // ms between dumps
#define MENU_CONFIG_ON 1
#define BUTTON_TRACE_ON 1
#define MAP_TRACE_ON 1


//uint8_t  HEAT_STEP_SIZE = 0;



// ##################################### END OPTIONS ####################################                         
// --------------------------------------------------------------------------------
// 5 rows to the menu 
#define DISPLAY_NUMBER_MENU_ITEMS  5
// 10 items in the menu for setting  
#define DISPLAY_NUMBER_MENU_FIELDS 10  


// counters are stored at the end of the eeprom
#define STORED_HEAT_SETTING_ADDRESS  0x1F8 // 
#define STORED_SETUP_FLAG_ADDRESS  0x1F0 // byte to indicate that have writen the defaults
#define STORED_SETUP_FLAG_VALUE    0xDEADBEEF  // specal indicator

#define EEPROM_PROFILE_SPACING  0x0100  //256 bytes

//-------------------------------------------------------------------
typedef union
{
	uint16_t		     Num;   // was int
	unsigned char    Bool;
}VALUE_UNION_TYPE;

//-------------------------------------------------------------------


// -------------------------------------------------------------------
// the rows are in INPUT_SELECTION order - ie [INPUT_SELECTION][column]
typedef struct
{
	VALUE_UNION_TYPE Values[DISPLAY_NUMBER_MENU_ITEMS][DISPLAY_NUMBER_MENU_FIELDS];
}DISPLAY_EEPROM_STORED_MENU_DATA;

// this is the data that needs to be stored in the eeprom
extern DISPLAY_EEPROM_STORED_MENU_DATA  TheDisplayEpromData ; 


// the rows are in INPUT_ROW order - ie [INPUT_SELECTION][column]
//typedef struct
//{
//	VALUE_UNION_TYPE Values[INPUT_NUMBER_MENU_ITEMS][INPUT_NUMBER_MENU_FIELDS];
//}INPUT_EEPROM_STORED_MENU_DATA;
 
// this is the data that needs to be stored in the eeprom
//extern INPUT_EEPROM_STORED_MENU_DATA  TheInputEpromData;

// configuration parameters - metric/mph , wheel size , tachoratio, odometer , clock, gears -1-6
#define CONFIG_NUMBER_PARAMS  34

#define CONFIG_PARAM_PROFILE        0  // the profile in use
#define CONFIG_WRITEN_FLAG          0x100


#define CONFIG_PARAM_HIGH_POL         0
#define CONFIG_PARAM_HIGH_MODE        1
#define CONFIG_PARAM_STARTER_POL      2
#define CONFIG_PARAM_STARTER_MODE     3
#define CONFIG_PARAM_LEFT_POL         4
#define CONFIG_PARAM_LEFT_MODE        5
#define CONFIG_PARAM_RIGHT_POL        6 
#define CONFIG_PARAM_RIGHT_MODE       7 
#define CONFIG_PARAM_HORN_POL         8
#define CONFIG_PARAM_HORN_MODE        9 
#define CONFIG_PARAM_KILL_POL         10
#define CONFIG_PARAM_KILL_MODE        11
#define CONFIG_PARAM_BRAKE_POL        12
#define CONFIG_PARAM_BRAKE_MODE       13
#define CONFIG_PARAM_LIGHTS_POL       14
#define CONFIG_PARAM_LIGHTS_MODE      15
#define CONFIG_PARAM_GATE_POL         16
#define CONFIG_PARAM_GATE_MODE        17

// outputs
#define CONFIG_PARAM_LIGHTS_OFF_CRANK        18
#define CONFIG_PARAM_LOW_OUT_ACT             19
#define CONFIG_PARAM_LIGHT_ON_POW            20
#define CONFIG_PARAM_MOD_LOW_BEAM            21
#define CONFIG_PARAM_MOD_LOW_DEPTH           22
#define CONFIG_PARAM_4_BUTTON_MODE           23
#define CONFIG_PARAM_STARTER_GATE            24
#define CONFIG_PARAM_STARTER_INH_KILL        25
#define CONFIG_PARAM_IND_MAX_FLASH_FLAG      26
#define CONFIG_PARAM_IND_MAX_LIM_VALUE       27
#define CONFIG_PARAM_IND_FLASH_RATE_VALUE    28
#define CONFIG_PARAM_BRAKE_WARN_FLASH_FLAG   29
#define CONFIG_PARAM_BRAKE_WARN_FLASH_VALUE  30
#define CONFIG_PARAM_BRAKE_WHEN_FLASH_FLAG   31  
#define CONFIG_PARAM_HEATED_GRIP_ON          32
#define CONFIG_PARAM_HEATED_GRIP_STEPS       33





typedef struct
{
	VALUE_UNION_TYPE Values[CONFIG_NUMBER_PARAMS];
}CONFIG_EEPROM_STORED_MENU_DATA;

extern CONFIG_EEPROM_STORED_MENU_DATA  TheConfigEpromData;


extern byte    gSTORED_DISPLAY;
extern bool    gSPEEDO_MODE;
extern bool    gMETRIC;
extern bool    gINJECTION;
extern bool    gDIAG_MODE_SET;
extern bool    gCONFIG_MODE_SET;
extern bool    gMETER_MODE_SET;
extern byte    gconfigval;



//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
